<?php
/*
Plugin Name: WP Bots Analytics
Plugin URI: http://www.giuseppepastore.com/en/portfolio/wp-bots-analytics-plugin/
Description: This plugin allows you to track search engine spiders and bots in a Google Analytics account.
Author: Giuseppe Pastore
Version: 3.0
Author URI: http://www.giuseppepastore.com/
*/
add_action('wp_head','insert_code');
add_action('admin_head','admin_register_wp_bots_head');
add_action('admin_menu','add_wp_bots_options_admin_menu');
/*add_action('wp_footer','add_credits');*/
/*** Prints the stylesheet link in the admin head. ***/
function admin_register_wp_bots_head(){
	$wp_content_url = 'http://'.$_SERVER['HTTP_HOST'];
	if(is_ssl()) {
		$wp_content_url = str_replace('http://', 'https://', $wp_content_url);
	}
	$url = $wp_content_url . '/wp-content/plugins/' . basename(dirname(__FILE__)) . '/css/bots-analytics.css';
	echo "<link rel='stylesheet' type='text/css' href='$url' />\r\n";
}
/*** Add the plugin options page link to the dashboard menu ***/
function add_wp_bots_options_admin_menu() {
  add_options_page(__('Wp Bots Analytics', 'bots-analytics'), __('Wp Bots Analytics', 'bots-analytics'), 'manage_options', basename(__FILE__), 'bots_analytics_options_page'); 
}
/*** Update the Google Analytics Injector plugin options ***/
function bots_analytics_options_update() {
  if(isset($_POST['ua_tracking_code'])) 
    update_option('ua_tracking_code', $_POST['ua_tracking_code']);
  if(isset($_POST['ua_tracking_code']) && !isValidUaCode($_POST['ua_tracking_code']))
    $errors = new WP_Error('tracking_code', __('The tracking code is on the wrong format', 'bots-analytics'));
  if(isset($_POST['utma_cookie']))
    update_option('utma_cookie', $_POST['utma_cookie']);
  if(isset($_POST['gimmelink']))
    update_option('gimmelink', $_POST['gimmelink'] );
  return $errors;
}
function add_credits(){
$gimmelink='on';
if (get_option('gimmelink')=='on') {}
}
/**
* Validate the format of the given Google Analytics Web Property ID.
* @param $ua_tracking_code the given Google Analytics Web Property ID to validate.
**/
function isValidUaCode($ua_tracking_code) {
	if($ua_tracking_code == '' || preg_match('/^UA-[0-9]*-[0-9]*$/', $ua_tracking_code)) {
		return true;}
	return false;
}
/*** The main function that generate the options page for this plugin. ***/
function bots_analytics_options_page() {

  $tracking_code_err = '';
  if ( $_POST['update_bots_analytics'] == 'true' ) {
  	$errors = bots_analytics_options_update(); 
    if (is_wp_error($errors)) 
      $tracking_code_err = $errors->get_error_message('tracking_code');
  } ?>
    <div class="wrap">
	<div id="icon-themes" class="icon32"><br /></div>
	<h2><?php echo __('WP Bots Analytics', 'bots-analytics'); ?></h2>
	<p><?php echo __('This plugin allows to tracks search engine spiders via Google Analytics without editing your Wordpress template files'); ?><br /><br />
	<?php echo __('If you appreciate it, please share your experience with it wherever you can. Thanks.'); ?></p>	
    	<div class="gai-col1">

        <form method="post" action="">
          
          <h4 style="margin-bottom: 0px;"><?php echo __('Web Property ID (UA-xxxx-x)', 'bots-analytics'); ?></h4>
		  <?php if ($tracking_code_err) echo ('<div class="errorMsg">'.$tracking_code_err.'</div>'); ?>
        
          <input type="text" name="ua_tracking_code" id="ua_tracking_code" value="<?php echo get_option('ua_tracking_code'); ?>" style="width:400px;"/>
          
          <h4 style="margin-bottom: 0px;"><?php echo __('UTMA Cookie', 'bots-analytics'); ?></h4>
          <input type="text" name="utma_cookie" id="utma_cookie" value="<?php echo get_option('utma_cookie'); ?>" style="width:400px;"/>
          
          
		  <h4 style="margin-bottom: 0px;"><?php echo __('I like this plugin!', 'bots-analytics'); ?></h4>
 <input type="hidden" name="gimmelink" value="<?php get_option('gimmelink'); ?>" />
          <input type="checkbox" name="gimmelink" id="gimmelink" <?php checked('on',get_option('gimmelink'),'off'); ?> />
		  
		  <input type="hidden" name="update_bots_analytics" value="true" />
          <p><input type="submit" name="search" value="<?php echo __('Update Options', 'bots-analytics'); ?>" class="button" /></p>
        </form>
		<a href="https://twitter.com/share" class="twitter-share-button" data-url="http://en.posizionamentozen.com/resource/wp-bots-analytics" data-text="I'm using &quot;WP Bots Analytics&quot; for #Wordpress by @zen2seo to track search engines bots on my blog in Google #Analytics" data-size="large">Tweet</a>
<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}}(document, 'script', 'twitter-wjs');</script>	
		
      </div>
      <div class="gai-col2">
      
      	<div class="description">
      		<?php echo __('Enter the Web Property ID from the Bots Google Analytics account you want to use for this site. The Web Property ID must be in the <b>format UA-XXXXXXX-YY</b>', 'bots-analytics'); ?>   	</div> 	
      	<div class="description">
      	  <?php echo __('Enter the _utma cookie that identifies your website', 'bots-analytics'); ?>
      	</div> 	
		
		<div class="description">
      	  <?php echo __('If you like this plugin, by <b>leaving this checkbox checked</b> you will provide a credits link to the developer', 'bots-analytics'); ?>
      	</div> 	
      </div>  
    </div>
<?php }
/**
 * Insert code to tracks spiders.
 */
function insert_code() {
/*** Includes Bots recognition ***/
$bots = array(	'Mediapartners-Google[ /]([0-9.]{1,10})' => 'Google Mediapartners',
				'Mediapartners-Google' => 'Google Mediapartners',
				'Googl(e|ebot)(-Image)/([0-9.]{1,10})' => 'Google Image',
				'Googl(e|ebot)(-Image)/' => 'Google Image',
				'^gsa-crawler' => 'Google',
				'Googl(e|ebot)(-Sitemaps)/([0-9.]{1,10})?' => 'Google-Sitemaps',
				'GSiteCrawler[ /v]*([0-9.a-z]{1,10})?' => 'Google-Sitemaps',
				'Googl(e|ebot)(-Sitemaps)' => 'Google-Sitemaps',
				'Googl(e|ebot)(-Mobile)/([0-9.]{1,10})?' => 'Google-Mobile',
				'^AdsBot-Google' => 'Google-AdsBot',
				'^Feedfetcher-Google' => 'Google-Feedfetcher',
				'compatible; Google Desktop' => 'Google Desktop',
				'compatible; Googlebot/([0-9.]{1,10})?' => 'Google',
				'compatible; bingbot/([0-9.]{1,10})?' => 'BingBot',
				'1Noonbot[/ ]([0-9.]{1,10})' => '1noon',
				'^Yeti$' => '1noon',
				'123spider-Bot \(Version: ([0-9.]{1,10})' => '123Spider',
				'192.comAgent' => '192.com',
				'2dehands\.nl' => '2deHands',
				'^A1 Sitemap Generator[ /]([0-9.]{1,10})' => 'A1 Sitemap',
				'miggibot[ /]([0-9.]{1,10})' => 'A1 Sitemap',
				'www\.a2b\.cc' => 'A2B',
				'^ABACHOBot' => 'Abacho',
				'^ABCdatos BotLink[ /]([0-9.]{1,10})' => 'ABCdatos',
				'^abot[ /]([0-9.]{1,10})' => 'aBot',
				'Libby[_/ ]([0-9.]{1,10})' => 'About',
				'About[_/ ]([0-9.]{1,10})libwww-perl' => 'About',
				'www.ackerm.com' => 'Ackerm',
				'^AcoiRobot' => 'AcoiRobot',
				'Acoon[ \-]?Robot' => 'Acoon',
				'Accoona-AI-Agent[/ ]([0-9.]{1,10})' => 'Accoona',
				'^accoona' => 'Accoona',
				'^Acme\.Spider' => 'Acme',
				'ActiveBookmark[/ ]([0-9.]{1,10})' => 'ActiveBookmark',
				'Ad Muncher[/ v]*([0-9.]{1,10})' => 'Ad Muncher',
				'^AESOP_com_SpiderMan' => 'Aesop',
				'^agadine[/ ]([0-9.]{1,10})' => 'Agada',
				'AIBOT[/ ]([0-9.]{1,10})' => 'Aibot',
				'aipbot[/ ]([0-9.]{1,10})' => 'Aipbot',
				'Aleksika Spider[/ ]([0-9.]{1,10})' => 'Aleksika',
				'ipd[ /]([0-9.]{1,10}).*Alertsite\.com' => 'AlertSite',
				'^ia_archive' => 'Alexa',
				'www\.almaden\.ibm\.com/cs/crawler' => 'IBM Crawler',
				'Scooter[ /\-]*[a-z]*([0-9.]{1,10})' => 'Altavista',
				'AltaVista V([0-9.]{1,10})' => 'Altavista',
				'AltaVista Intranet V([0-9.]{1,10})' => 'Altavista',
				'^(aranhabot|amzn_assoc)' => 'Amazon',
				'^NutchEC2Test' => 'Amazon',
				'^amibot' => 'Amidalla',
				'Amfibibot[/ ]([0-9.]{1,10})' => 'Amfibi',
				'Amfibibot' => 'Amfibi',
				'AmphetaDesk[/ ]([0-9.]{1,10})' => 'AmphetaDesk',
				'amphetameme[ \-]?crawler' => 'Amphetameme',
				'^AnnoMille( spider)?[/ ]([0-9.]{1,10})' => 'AnnoMille',
				'AnsearchBot[/ ]([0-9.]{1,10})' => 'Ansearch',
				'AnswerChase( PROve)?[/ ]([0-9.]{1,10})' => 'AnswerChase',
				'antibot-V([0-9.]{1,10})' => 'antibot',
				'^AONDE-Spider' => 'Aonde',
				'^A-Online Search' => 'A-Online.at',
				'^AOLserver-Tcl[/ ]([0-9.]{1,10})' => 'AOLserver',
				'^AOLserver' => 'AOLserver',
				'ApacheBench[ /]([0-9.]{1,10})' => 'ApacheBench',
				'^BebopBot[ /]([0-9.]{1,10})' => 'Passion 4 Jazz',
				'^Apexoo Spider ([0-9.]{1,10})' => 'Apexoo',
				'^Aport' => 'Aport',
				'appie[ /]([0-9.]{1,10})' => 'Walhello',
				'compatible; Arachmo' => 'Arachmo',
				'^X-Crawler' => 'Arexera',
				'^TECOMAC-Crawler[ /]([0-9.]{1,10})' => 'Arexera',
				'^www.arianna.it' => 'Arianna',
				'^ArtfaceBot' => 'Artface',
				'Sleek Spider[ /]([0-9.]{1,10})' => 'Any Search Info',
				'Ask[ \-]?Jeeves' => 'Ask Jeeves',
				'teomaagent' => 'Ask Jeeves',
				'^AskAboutOil[ /]([0-9.]{1,10})' => 'ASPseek',
				'^asked[ /]Nutch[ \-]([0-9.]{1,10})' => 'askEd!',
				'^ASPseek[/ ]([0-9.]{1,10})' => 'ASPseek',
				'AtlocalBot[/ ]([0-9.]{1,10})' => 'At Local',
				'Atomz[/ ]([0-9.]{1,10})' => 'Atomz',
				'^axel' => 'Axel',
				'AxmoRobot' => 'Axmo',
				'answerbus' => 'AnswerBus',
				'AutoMapIt[ /](Bot)?' => 'AutoMapIt',
				'augurnfind[/ ][v\-]*([0-9.]{1,10})' => 'Augurnfind',
				'Awasu[/ ]([0-9a-z.]{1,10})' => 'Awasu',
				'BACS http://www.ba.be' => 'ba.be',
				'Baiduspider' => 'Baidu',
				'www\.thebananatree\.org' => 'BananaTree',
				'bdcindexer_([0-9a-z.]{1,10})' => 'bdcindexer',
				'^BDFetch' => 'BDFetch',
				'BDNcentral Crawler v([0-9.]{1,10})' => 'Bdncentral',
				'^BeamMachine[ /]([0-9.]{1,10})' => 'BeamMachine',
				'Become(JP)?Bot[/ ]([0-9.]{1,10})' => 'Become',
				'(BecomeBot|Exabot)@exava\.com\)$' => 'Become',
				'BeebwareDirectory[/ ]v?([0-9.]{1,10})' => 'Beebware',
				'^Big Brother' => 'Big Brother',
				'^BigCliqueBOT[/ ]([0-9.]{1,10})' => 'BigClique',
				'^BIGLOTRON' => 'Biglotron',
				'Bigsearch.ca[/ ]Nutch[- ]([0-9.]{1,10})' => 'Bigsearch',
				'Bilbo[ /]([0-9.]{1,10})' => 'Bilbo',
				'Bilgi(Beta)?Bot[ /]([0-9.]{1,10})' => 'Bilgi',
				'Bitacle (ro)?bot[ \(/V\:]+([0-9.]{1,10})' => 'Bitacle',
				'BitBeamer/([0-9.]{1,10})' => 'BitBeamer',
				'^Biz360 spider' => 'Biz360',
				'Blaiz-Bee[ /]([0-9.]{1,10})' => 'Blaiz-Bee',
				'Naamah[ /]([0-9.a-z]{1,10})[ /]Blogbot' => 'blogbot.de',
				'^Blogcensus' => 'Blogcensus',
				'Blogdex[ /]([0-9.]{1,10})' => 'Blogdex',
				'^blogg\.de' => 'Blogg',
				'BlogLand[/ ]([0-9.]{1,10})' => 'BlogLand',
				'Bloglines[ /]([0-9.]{1,10})' => 'Bloglines',
				'Bloglines' => 'Bloglines',
				'blogmap' => 'Blogmap',
				'Blogosphere' => 'Blogosphere',
				'BlogPeople' => 'BlogPeople',
				'Blogpulse' => 'Blogpulse',
				'^BlogRanking(/RSS checker)?' => 'BlogRanking',
				'blo\.gs[ /]([0-9.]{1,10})' => 'Blo.gs',
				'blo\.gs' => 'Blo.gs',
				'BlogShares[ /]V?([0-9.]{1,10})' => 'BlogShares',
				'(^| |\()Blogshares(\.com| |\))' => 'BlogShares',
				'Blogslive' => 'BlogsLife',
				'blogsnowbot' => 'BlogsNow',
				'BlogsNow' => 'BlogsNow',
				'^BlogStreetBot' => 'BlogStreet',
				'nomadscafe_ra[/ ]([0-9.]{1,10})' => 'BlogSurf',
				'BlogTickServer' => 'BlogTick',
				'blogWatcher_Spider[/ ]([0-9.]{1,10})' => 'Blogwatcher',
				'Blogwise\.com(-MetaChecker)?[/ ]([0-9.]{1,10})' => 'Blogwise',
				'BoardReader[ \-](Image|Favicon)[ \-]Fetcher[ /]+([0-9.]{1,10})' => 'BoardReader',
				'bobby[ /]([0-9.]{1,10})' => 'Bobby',
				'Boitho\.com[ \-](dc|robot)?[/ ]([0-9.]{1,10})' => 'Boitho',
				'^booch[_ /]([0-9.]{1,10})' => 'Booch',
				'http://www\.bookmark\.ne\.jp' => 'Bookmark',
				'^Bookdog[ /]([0-9.]{1,10})' => 'Bookdog',
				'BorderManager[ /]([0-9.]{1,10})' => 'Border Manager',
				'BottomFeeder[ /]([0-9.]{1,10})' => 'BottomFeeder',
				'BrowserEmulator[ /]([0-9.]{1,10})' => 'BrowserEmulator',
				'Browsershots URL Check' => 'Browsershots',
				'BrowserSpy' => 'BrowserSpy',
				'BruinBot' => 'BruinBot',
				'^Bruno' => 'Bruno',
				'BTbot/([0-9.]{1,10})' => 'BitTorrent',
				'Bulkfeeds[/ ]([a-z0-9.]{1,10})' => 'Bulkfeeds',
				'^Norbert the Spider' => 'Burf.com',
				'Butch(__| )?([a-z0-9.]{1,10})' => 'Butch',
				'^Camcrawler' => 'Camdiscover',
				'^CazoodleBot/(Nutch|CazoodleBot)[/ \-]([0-9.]{1,10})' => 'Cazoodle',
				'CCGCrawl[/ ]([0-9.]{1,10})' => 'CCGCrawl',
				'^Cerberian Drtrs' => 'Cerberian Drtrs',
				'^CFNetwork[/ ]([0-9.]{1,10})' => 'Cerberian Drtrs',
				'Charlotte[/ ]([0-9a-z.]{1,10})' => 'Charlotte',
				'Cirilizator[/ ]([0-9.]{1,10})' => 'Cirilizator',
				'(Claria|Diamond)(Bot)?[ /]([0-9.]{1,10})' => 'Claria',
				'(Claria|Diamond)(Bot)' => 'Claria',
				'claymont\.com' => 'Claymont',
				'OliverPerry' => 'Claymont',
				'Clus(tered-Search-|h)Bot[ /]([0-9.]{1,10})' => 'Clush',
				' (QXW03018|obot)\)' => 'Cobion',
				'^coldfusion' => 'ColdFusion',
				'Combine[ /]([0-9.]{1,10})' => 'Combine',
				'^comBot[ /]([0-9.]{1,10})' => 'comBot',
				'cometsearch@cometsystems' => 'Comet',
				'Commerobo[/ ]([0-9.]{1,10})' => 'Commerobo',
				'Comrite[/ ]([0-9.]{1,10})' => 'ComRite',
				'Convera(MultiMedia)?Crawler[/ ]([0-9.]{1,10})' => 'Convera',
				'Convera Internet Spider V([0-9.]{1,10})' => 'Convera',
				'^CoolBot' => 'CoolBot',
				'^(voyager|cfetch|CosmixCrawler|carleson)[/ ]([0-9.]{1,10})' => 'Cosmix',
				'^cosmos' => 'Cosmos',
				'^beautybot[/ ]([0-9.]{1,10})' => 'Cosmoty',
				'CreativeCommons[/ ]([0-9.]{1,6}(-dev)?)' => 'Creative Commons',
				'CsCrawler' => 'CsCrawler',
				'CSS(Check|_Validator)' => 'CSSCheck',
				'Custo[ /]([0-9.]{1,10})' => 'Custo',
				'CyberNavi_WebGet[ /]([0-9.]{1,10})' => 'CyberNavi',
				'Cyberz Communication Agent' => 'Cyberz',
				'CydralSpider[ /]([0-9.]{1,10})' => 'Cydral',
				'Cynthia[ /]([0-9.]{1,10})' => 'Cynthia Says',
				'Downloader for X[ /]([0-9.]{1,10})' => 'Downloader for X',
				'^DA[ /]([0-9.]{1,10})' => 'DA',
				'DAUMOA[ /]([0-9.]{1,10})' => 'DAUM',
				'DAUM Web Robot' => 'DAUM',
				'Daum Communications Corp' => 'DAUM',
				'EDI[ /]([0-9.]{1,10})' => 'DAUM',
				'Edacious.*Intelligent Web Robot' => 'DAUM',
				'RaBot[/ ]([0-9.]{1,10}) Agent' => 'DAUM',
				'daypopbot[/ ]([0-9.]{1,10})' => 'Daypop',
				'crawl at delfi dot lt' => 'Delfi',
				'DepSpid[/ ]([0-9.]{1,10})' => 'DepSpid',
				'DEVONtech' => 'DEVONagent',
				' Diffbot' => 'Diffbot',
				'EZResult -- Internet Search Engine' => 'Direct Hit',
				'disco/Nutch[/ -]([0-9.]{1,10})' => 'disco',
				'disco-crawl@discoveryengine.com' => 'disco',
				'DISCo Pump[/ ]([0-9.]{1,10})' => 'DISCo Pump',
				'DNS-Digger-Explorer[ /]([0-9.]{1,10})' => 'DNS-Digger',
				'Doctor[ \-]?HTML' => 'DoctorHTML',
				'DomaindateiSpider[ /]([0-9.]{1,10})' => 'Domaindatei',
				'^www.doweb.co.uk' => 'DoWeb',
				'Download Ninja[ /]([0-9.]{1,10})' => 'Download Ninja',
				'^Drupal' => 'Drupal',
				'^DSNS' => 'DSNS Scanner',
				'DTS Agent' => 'DTS Agent',
				'EARTHCOM\.info[/ ]([0-9a-z.]{1,10})' => 'Earthcom',
				'eBay Relevance Ad Crawler' => 'eBay',
				'_TrueRobot[/ ]([0-9.]{1,10})' => 'Echo.com',
				'eert spdr[/ ]([0-9.]{1,10})' => 'eert',
				'eknip[ /]([0-9a-z.]{1,10})' => 'E-Knip',
				'NextGenSearchBot[/ ]([0-9.]{1,10})' => 'Eliyon',
				'^EmeraldShield' => 'EmeraldShield',
				'DigExt; empas\)$' => 'Empas',
				'^EMPAS[_\-]ROBOT' => 'Empas',
				'Speedy[ ]?Spider' => 'Entireweb',
				'envolk\[ITS\]spider[/ ]([0-9.]{1,10})' => 'Envolk',
				'envolk[/ ]([0-9.]{1,10})' => 'Envolk',
				'ES.NET Crawler[ /]([0-9.]{1,10})' => 'ES.NET',
				'eStyleSearch[ /]([0-9.]{1,10})' => 'eStyle Search',
				'EuripBot[ /]([0-9.]{1,10})' => 'Eurip',
				'www\.euro-directory\.com' => 'Euro Directory',
				'Arachnoidea' => 'EuroSeek',
				'^EvaalSE' => 'Evaal',
				'^eventax[ /]([0-9.]{1,10})' => 'Eventax',
				'EverbeeCrawler' => 'Everbee',
				'Everest-Vulcan Inc.[ /]([0-9.]{1,10})' => 'Everest',
				'^NG[ /]([0-9.]{1,10})' => 'ExaBot',
				'Exabot/([0-9.]{1,10})' => 'ExaBot',
				'ExaBotTest/([0-9.]{1,10})' => 'ExaBot',
				'ExaBot-(Test|Images)/([0-9.]{1,10})' => 'ExaBot',
				'^exactseek[ \-]?(pagereaper|crawler)[ \-]?([0-9.]{1,10})' => 'ExactSeek',
				'ExactSeek[ \.\-]?(Crawler|com)' => 'ExactSeek',
				'Architext[ \-]?Spider' => 'Excite',
				'Execrawl[ /]([0-9.]{1,10})' => 'Execrawl',
				'Execrawl' => 'Execrawl',
				'^NetMonitor[ /]([0-9.]{1,10})' => 'ExpertMonitor',
				'^Windows-RSS-Platform[ /]([0-9.]{1,10})' => 'Explorer RSS',
				'FacebookFeedParser[/ ]([0-9a-z.\-]{1,10})' => 'Facebook',
				'^FAST( Enterprise |-Web| MetaWeb )?Crawler[ /]([0-9.]{1,10})' => 'Fast',
				'^FAST( Enterprise |-Web| MetaWeb | PartnerSite )?Crawler' => 'Fast',
				'^Fast Crawler' => 'Fast',
				'^libwww-perl[ /]([0-9.]{1,10}) FP[ /]([0-9.]{1,10})' => 'Fast',
				'^fastbuzz\.com' => 'Fastbuzz',
				'^FavOrg' => 'FavOrg',
				'favorstarbot[ /]([0-9.]{1,10})' => 'favorstar',
				'^Faxobot[ /]([0-9.]{1,10})' => 'Faxo',
				'FDSE[ \-]?robot' => 'FDSE Robot',
				'FeedBack[/ ]([0-9.]{1,10})' => 'FeedBack',
				'^FeedBurner[/ ]([0-9.]{1,10})' => 'FeedBurner',
				'FeedDemon[/ ]([0-9.]{1,10})' => 'FeedDemon',
				'Feed::Find[ /]([0-9.]{1,10})' => 'FeedFind',
				'FeedOnFeeds[/ ]([0-9.]{1,10})' => 'Feed On Feeds',
				'UniversalFeedParser[/ ]([0-9a-z.\-]{1,10})' => 'Feedparser',
				'FeedParser' => 'Feedparser',
				'^Feedreader' => 'Feedreader',
				'FeedServer[/ ]([0-9.]{1,10})' => 'FeedServer',
				'Feedster Crawler[/ ]([0-9.]{1,10})' => 'Feedster',
				'^FeedValidator[/ ]([0-9.]{1,10})' => 'Feed Validator',
				'^FDM[/ ]([0-9a-z.]{1,10})' => 'Free Download Manager',
				'Filangy[/ ]([0-9.]{1,10})' => 'Filangy',
				'FindAnISP' => 'FindAnISP',
				'FindEngines! Bot' => 'FindEngines',
				'Findexa Crawler' => 'Findexa',
				'findlinks[ /]([0-9.]{1,10})' => 'FindLinks',
				'^FindLinks' => 'FindLinks',
				'^findoor(-Bot)?' => 'findoor',
				'Firefly' => 'Firefly',
				'^FlashGet' => 'FlashGet',
				'FlickBot[ /]([0-9.]{1,10})' => 'FlickBot',
				'^Forex Trading Network Organization' => 'Forex',
				'fmII URL validator[ /]([0-9.]{1,10})' => 'freshmeat',
				'freshmeat.net URL validator[ /]([0-9.]{1,10})' => 'freshmeat',
				'www\.friend\.fr' => 'Friend',
				'Frontier[ /]([0-9.]{1,10})' => 'Frontier',
				'Gaisbot[ /]([0-9.]{1,10})' => 'Gaisbot',
				'GalaxyBot[ /]([0-9.]{1,10})' => 'Galaxy',
				'www.galaxy.com' => 'Galaxy',
				'GameSpyHTTP[ /]([0-9.]{1,10})' => 'GameSpy',
				'Genome[ \-]?Machine' => 'Genome Machine',
				'GeonaBot[ /]([0-9.]{1,10})' => 'Geona',
				'The World as a Blog' => 'The World as a Blog',
				'geourl[ /]([0-9.]{1,10})' => 'GeoUrl',
				'^GeoURLBot[ /]([0-9.]{1,10})' => 'GeoUrl',
				' Crayon Crawler' => 'GetNetWise',
				'GetRight[ /]([0-9.]{1,10})' => 'GetRight',
				'GetSmart[ /]([0-9.]{1,10})' => 'GetSmart',
				'(Gigabot|Sitesearch)[/ ]([0-9.]{1,10})' => 'Gigablast',
				'GigabotSiteSearch[/ ]([0-9.]{1,10})' => 'Gigablast',
				'Girafabot' => 'Girafa',
				'Ocelli[ /]([0-9.]{1,10})' => 'GlobalSpec',
				'glucose[ /]([0-9a-z.\-]{1,10})' => 'Glucose',
				'^GoForIt\.com' => 'GoForIt',
				'^GOFORITBOT' => 'GoForIt',
				'^GoGuidesBot[ /]([0-9.]{1,10})' => 'GoGuides',
				'(gazz|ichiro|mog(et|imogi))[ /]([0-9.]{1,10})' => 'Goo',
				'DoCoMo[ /]([0-9.]{1,10})' => 'Goo',
				'^Big Fish[ /]v?([0-9.]{1,10})' => 'GoonGee',
				'^GPostbot' => 'GPost',
				'^Gregarius[/ ]([0-9.]{1,10})' => 'Gregarius',
				'grub[ \-]?client[ /\-]{1,5}([0-9.]{1,10})' => 'Grub',
				'grub crawler' => 'Grub',
				'Gulliver' => 'Gulliver',
				'^GurujiBot[/ ]([0-9.]{1,10})' => 'Guruji',
				'^Gush[/ ]([0-9.]{1,10})' => 'Gush',
				'g(id)?zip[ \-]?test(er)?' => 'Gzip Tester',
				'^Hanzoweb' => 'Hanzoweb',
				'^Harbot GateStation' => 'Harbot',
				'Hatena (Antenna|Bookmark|Pagetitle Agent)[ /]([0-9.]{1,10})' => 'Hatena',
				'^helix[ /]([0-9.]{1,10})' => 'Heritrix',
				'heritrix[ /]([0-9.]{1,10})' => 'Heritrix',
				'archive.org_bot' => 'Heritrix',
				'InternetArchive[ /]([0-9.a-z]{1,10})' => 'Heritrix',
				'HiddenMarket[ /\-]([0-9.]{1,10})' => 'HiddenMarket',
				'Honda-Search[ /]([0-9.]{1,10})' => 'Honda',
				'HooWWWer[ /]([0-9.]{1,10})' => 'HooWWWer',
				'Hotzonu[ /]([0-9.]{1,10})' => 'Hotzonu',
				'HouxouCrawler[ /]Nutch.([0-9.]{1,10})' => 'Houxou',
				'HouxouCrawler' => 'Houxou',
				'htdig[ /]([0-9.]{1,10})' => 'ht://Dig',
				'^HTML2JPG' => 'HTML2JPG',
				'httperf[ /]([0-9.]{1,10})' => 'HTTPerf',
				'httpunit[ /]([0-9.]{1,10})' => 'HttpUnit',
				'HTTrack[ /]([0-9.]{1,10})' => 'HTTrack',
				'HuRob[ /]([0-9.]{1,10})' => 'Hungary',
				'iaskspider[ /]([0-9.]{1,10})' => 'IAsk',
				'^iaskspider' => 'IAsk',
				'^ICC-Crawler' => 'ICC-Crawler',
				'BlogzIce[ /]([0-9.]{1,10})' => 'Icerocket',
				'BlogSearch[ /]([0-9.]{1,10})' => 'Icerocket',
				'^ICRA_Semantic_spider[ /]([0-9.]{1,10})' => 'ICRA',
				'^Mozilla[/ ]([0-9.]{1,10})[/ ]\(compatible[ ;]*ICS' => 'Novell iChain Cool Solutions caching',
				'Comaneci_bot[ /]([0-9.]{1,10})' => 'I know',
				'ilial[ /]Nutch[ \-]([0-9.]{1,10})' => 'Ilial',
				'I(NGRID|lseRobot|lseBot)[ /]([0-9.]{1,10})' => 'Ilse',
				'iltrovatore-setaccio[ /]([0-9.]{1,10})' => 'IlTrovatore',
				'Iltrovatore-Setaccio' => 'IlTrovatore',
				'iltrovatore[ /]([0-9.]{1,10})' => 'IlTrovatore',
				'Indy[ \-]?Library' => 'Indy Library',
				'InelaBot[ /]([0-9.]{1,10})' => 'Inela',
				'InetURL.?[ /]([0-9.]{1,10})' => 'InetURL',
				'InfoArt crawler' => 'InfoArt',
				'^DataFountains/DMOZ' => 'INFOMINE',
				'^INFOMINE[ /]([0-9.]{1,10})' => 'INFOMINE',
				'SideWinder[ /]?([0-9a-z.]{1,10})' => 'Infoseek',
				'Infoseek' => 'Infoseek',
				'slurp@inktomi\.com' => 'Inktomi',
				'^InnerpriseBot[ /]([0-9.]{1,10})' => 'Innerprise',
				'URL[ _]Spider[ _]Pro[ /]([0-9.+]{1,10})' => 'Innerprise',
				'^ES[ .]NET[ _]Crawler[ /]([0-9.]{1,10})' => 'Innerprise',
				'^xyro_' => 'Inria',
				'^Insitor(,|\.|naut)' => 'Insitor',
				'^Internet Ninja[ /]([0-9.]{1,10})' => 'Internet Ninja',
				'^InternetSeer\.com' => 'InternetSeer',
				'Interseek.com' => 'Interseek',
				'IntraVnews[ /]([0-9.]{1,10})' => 'IntraVnews',
				'^IP2(Map|Location)Bot[ /]([0-9.]{1,10})' => 'IP2LocationBot',
				'^IP\*Works\! V([0-9.]{1,10})' => 'IP*Works',
				'^ICRA_(label_generator|Semantic_spider)[ /]([0-9.]{1,10})' => 'Novell iChain Cool Solutions caching',
				'Irvine[ /]([0-9.]{1,10})' => 'Irvine',
				'ips-agent' => 'ips-agent',
				'ISSpider[ /\-]([0-9.]{1,10})' => 'ISSpider',
				'iVia Site Checker.?[ /]([0-9.]{1,10})' => 'iVia',
				'Jetbot[ /]([0-9.]{1,10})' => 'Jeteye',
				'Jigsaw[ /]([0-9.]{1,10})' => 'Jigsaw',
				'www\.jobs\.de' => 'jobs.de',
				'jobs.de-Robot' => 'jobs.de',
				'JPluck[ /]([0-9a-z.]{1,10})' => 'Jpluck',
				'falcon[ /]([0-9.]{1,10})' => 'Jxta',
				'jyte_fetcher[ /]([0-9.]{1,10})' => 'Jyte',
				'Jyxobot[ /]([0-9.]{1,10})' => 'Jyxo',
				'EasyDL[ /]([0-9.]{1,10})' => 'Keywen',
				'kinjabot[ /]([0-9.]{1,10})' => 'Kinja',
				'^kinjabot' => 'Kinja',
				'lachesis' => 'Lachesis',
				'lanshanbot[/ ]([0-9.]{1,10})' => 'Lachesis',
				'LapozzBot[/ ]?([0-9.]{1,10})' => 'Lapozz',
				'larbin[_/ ]?([0-9.]{1,10})' => 'Larbin',
				'^IPiumBot' => 'Laurion',
				'^LeechGet[ /]([0-9.]{1,10})' => 'LeechGet',
				'Linkguard Online[ /]([0-9.]{1,10})' => 'Linkguard',
				'\(compatible; Linkman\)' => 'Linkman',
				'checklink[ /]([0-9.]{1,10})' => 'Linkcheck',
				'Link[ \-]?(Chec(k|ker)|Val(et|idator))' => 'Linkcheck',
				'Adaxas Spider' => 'Linkcheck',
				'Agent-SharewarePlazaFileCheckBot[ /]([0-9.]{1,10})' => 'Linkcheck',
				'NetMechanic V([0-9.]{1,10})' => 'Linkcheck',
				'^InfoLink' => 'Linkcheck',
				'InternetLinkAgent' => 'Linkcheck',
				'; SPENG\)' => 'Linkcheck',
				'SharewarePlazaFileCheckBot' => 'Linkcheck',
				'fileboost.net' => 'Linkcheck',
				'^billbot' => 'Linkcheck',
				'^Link.RU bot' => 'Link.RU',
				'links sql' => 'Links SQL',
				'LinkSweeper[ /]([0-9.]{1,10})' => 'Link Sweeper',
				'^LinkWalker' => 'Link Walker',
				'^Livedoor( SF( - California Crawl)?|Checkers)[ /]' => 'Livedoor',
				'^LiveJournal\.com' => 'Live Journal',
				'LjSEEK Picture-Bot[ /]+([0-9.]{1,10})' => 'ljpic',
				'^lmspider' => 'Lmspider',
				'^FiNDoBot[/ ]([0-9a-z.]{1,10})' => 'Locaters',
				'www\.look\.com' => 'Look',
				'Lookbot' => 'Look',
				'^Martini' => 'LookSmart',
				'^MantraAgent' => 'LookSmart',
				'FurlBot' => 'LookSmart',
				'looksmart-sv-fw' => 'LookSmart',
				'NetResearchServer[ /]([0-9.]{1,10})' => 'LOOP',
				'Lotkyll' => 'Lotkyll',
				'lwp(-trivial|::simple)[ /]([0-9.]{1,10})' => 'lwp',
				'Lycos_Spider_' => 'Lycos',
				'MagpieRSS' => 'MagpieRSS',
				'Mail[ \-]?Sweeper' => 'Mail Sweeper',
				'^Marvin' => 'Marvin',
				'Mosad[ /]([0-9.]{1,10})' => 'Mat\'Kurja',
				'Mavicanet robot' => 'Mavicanet',
				'^libwww[ /]([0-9.]{1,10})' => 'Mediater',
				'Mercator' => 'Mercator',
				'^RRC (crawler_admin@bigfoot.com)' => 'Metacarta',
				'^flunky' => 'Metacarta',
				'^Mozilla.*\(samualt9@bigfoot.com\)$' => 'Metacarta',
				'MetaGer' => 'MetaGer',
				'^XRL[ /]([0-9.a-z]{1,10})' => 'Metamark',
				'MediBot[ /]([0-9.]{1,10})' => 'MetaMedic',
				'Mirago' => 'Mirago',
				'AlgoFeedback@miva\.com' => 'Miva',
				'Mj12bot[ /]v?([0-9.]{1,10})' => 'Majestic-12',
				'MJ12bot \(mini\)[ /]([0-9.]{1,10})' => 'Majestic-12',
				'Mnogosearch[ /\-]([0-9.]{1,10})' => 'Mnogo',
				'MojeekBot[ /]([0-9.]{1,10})' => 'MojeekBot',
				'MOMspider[ /]([0-9.]{1,10})' => 'MOM Spider',
				'^Moreoverbot[ /]([0-9.]{1,10})' => 'Moreover',
				'MovableType[ /]([0-9.]{1,10})' => 'Movable Type',
				'mozDex[ /]([0-9.]{1,6}(-dev)?)' => 'MozDex',
				'MQbot' => 'MQbot',
				'MSN(BOT|PTC)[ /]([0-9.]{1,10})' => 'MSN',
				'MS Search ([0-9.]{1,10}) Robot' => 'MSN',
				'MSNBOT_Mobile' => 'MSN Mobile',
				'MSMOBOT' => 'MSN Mobile',
				'MSNBOT-(MEDIA|PRODUCTS)[ /]([0-9.]{1,10})' => 'MS Live Search',
				'MSProxy[ /]([0-9.]{1,10})' => 'MSProxy',
				'^MSRBOT' => 'MSRBOT',
				'Microsoft[ \-]?WebDAV[ \-]?MiniRedir' => 'MS-WebDAV',
				'MTIcon[/ ]([0-9.]{1,10})' => 'MTIcon',
				'MyRSS.jp[/ ]([0-9.]{1,10})' => 'MyRSS',
				'Multimap Geotag Blog Parser[/ ]([0-9.]{1,10})' => 'Multimap',
				'Najdi.si' => 'Najdi.si',
				'NPBot' => 'Name Protect',
				'NationalDirectory-WebSpider[ /]([0-9.]{1,10})' => 'National Directory',
				'NATSU[ \-]MICAN[/ ]([0-9a-z.]{1,10})' => 'Natsu Mican',
				'NaverBot([_\-]dloader)?[/ \-]([0-9.]{1,10})' => 'Naver',
				'Naver(Bot)?' => 'Naver',
				'^nabot' => 'Naver',
				'Navisso(Bot)?' => 'Navisso',
				'www.neofonie.de' => 'neofonie',
				'Francis[ /]([0-9.]{1,10})' => 'Neomo',
				'Nessus\)$' => 'Nessus',
				'NetAnts[ /]([0-9.]{1,10})' => 'NetAnts',
				'netcraft' => 'Netcraft',
				'Netluchs[ /]([0-9.a-z]{1,10})' => 'Netluchs',
				'NetMechanic[ /V]{1,5}([0-9.]{1,10})' => 'NetMechanic',
				'NetNose[ \-]Crawler[/ ]([0-9.]{1,10})' => 'NetNose',
				'netoskop' => 'Netoskop',
				'NetPromoter Spider' => 'NetPromoter',
				'^netprospector' => 'Netprospector',
				'^NetPumper[/ ]([0-9.]{1,10})' => 'Netpumper',
				'Netscape-Proxy[/ ]([0-9.]{1,10})' => 'Netscape Proxy',
				'^WebFilter Robot ([0-9.]{1,10})' => 'NetSpective',
				'^Netvibes' => ' Netvibes',
				'NewsFire[/ ]([0-9.]{1,10})' => 'NewsFire',
				'NewsGato(r|rOnline)[/ ]([0-9.]{1,10})' => 'NewsGator',
				'NewzCrawler[/ ]([0-9.]{1,10})' => 'NewzCrawler',
				'^NextopiaBOT.*[v ]([0-9.]{1,10})' => 'NewzCrawler',
				'NG-Search[/ ]([0-9.]{1,10})' => 'NG Search',
				'NimbleCrawler[/ ]([0-9.]{1,10})' => 'Nimble',
				'^nuSearch' => 'NuSearch',
				'Noago Spider' => 'Noago',
				'TridentSpider[/ ]?([0-9.]{1,10})' => 'Noviforum',
				'noxtrumbot[/ ]?([0-9.]{1,10})' => 'noXtrum',
				'noyona.([0-9._]{1,10})' => 'Noyona',
				'Nsauditor[ /]([0-9.]{1,10})' => 'Nsauditor',
				'obidos[ \-]?bot' => 'Bookwatch',
				'ObjectsSearch[ /]([0-9.]{1,10})' => 'Objects Search',
				'^oBot ' => 'oBot',
				'^Octora (Beta)?' => 'Octora',
				'^Offline Explorer[ /]([0-9.]{1,10})' => 'OfflineExplorer',
				'Omea Reader[ /]([0-9.]{1,10})' => 'Omea Reader',
				'OnetSzukaj[ /]([0-9.]{1,10})' => 'Onet',
				'^Onet\.pl' => 'Onet',
				'inktomi.search.onet' => 'Onet',
				'^Online24-Bot .* ([0-9.]{1,10})' => 'online24',
				'^onCHECK-Robot' => 'onsearch',
				'^OntoSpider[ /]([0-9.]{1,10})' => 'OntoSpider',
				'openbot[ /]([0-9.]{1,10})' => 'Openfind',
				'Openfind Robot[ /]([0-9.A-Z]{1,10})' => 'Openfind',
				'^OpenTaggerBot' => 'OpenTagger',
				'^OpenTextSiteCrawler[ /]([0-9.]{1,10})' => 'OpenText',
				'^OpenWebSpider[ /]([0-9.]{1,10})' => 'OpenWebSpider',
				'crawler@organica\.us' => 'Organica',
				'OutfoxMelonBot[ /]([0-9.]{1,10})' => 'Outfox Melon',
				'OutfoxBot[ /]([0-9.]{1,10})' => 'Outfox Melon',
				'Overture[ \-]?WebCrawler' => 'Overture',
				'^PageBitesHyperBot[ /]([0-9.]{1,10})' => 'PageBites',
				'PanopeaBot[/ ]([0-9.]{1,10})' => 'PanopeaBot',
				'^PEERbot' => 'Peerbot',
				'^PHP[ /]([0-9.]{1,10})' => 'PHP',
				'^PhpDig[ /]([0-9.]{1,10})' => 'PhpDig',
				'^PHP version tracker' => 'PHP version tracker',
				'^PictureOfInternet[ /]([0-9.]{1,10})' => 'PictureOfInternet',
				'^Pingdom GIGRIB v([0-9.]{1,10})' => 'Pingdom',
				'^Pingdom GIGRIB' => 'Pingdom',
				'www\.pinseri\.com/bloglist' => 'Pinseri',
				'Plagger[ /]([0-9.]{1,10})' => 'Plagger',
				'Planet[ /]([0-9.]{1,10})' => 'Planet',
				'PlantyNet_WebRobot[_ /]V?([0-9.]{1,10})' => 'PlantyNet',
				'PluckFeedCrawler[ /]([0-9.]{1,10})' => 'Pluck',
				'fido[ /]([0-9.]{1,10}) Harvest' => 'PlanetSearch',
				'^POE-Component-Client-HTTP[/ ]([0-9.]{1,10})' => 'POE-Component',
				'Pogodak\.hr[/ ]?([0-9.]{1,10})' => 'Pogodak',
				'P(oo|ooo)dle[ \-]?predictor[ \-]?([0-9.]{1,10})' => 'Poodle predictor',
				'P(oo|ooo)dle[ \-]?predictor' => 'Poodle predictor',
				'Pompos[ /]([0-9.]{1,10})' => 'Pompos',
				'Popdexter' => 'Popdexter',
				'Powermarks[ /]([0-9.]{1,10})' => 'Powermarks',
				'^PROBE!' => 'PROBE!',
				'^Mozilla/[0-9.]{1,10} \(compatible\;\)$' => 'Proxy Cache',
				'ProxyHunter' => 'ProxyHunter',
				'^psbot' => 'PicSearch',
				'^PubSub-RSS-Reader[ /]([0-9.]{1,10})' => 'PubSub',
				'^PubSub\.com' => 'PubSub',
				'PukiWiki[ /]([0-9.]{1,10})' => 'PukiWiki',
				'^PWeBot[ /]([0-9.]{1,10})' => 'PWeBot/X.Y',
				'^pxys' => 'PXYS',
				'^Qango.com' => 'Qango',
				'QihooBot[ /]([0-9.]{1,10})' => 'Qihoo',
				'Quantcastbot[ /]([0-9.]{1,10})' => 'Quantcast',
				'Quepasa[ \-]?Creep' => 'Quepasa',
				'www\.questfinder\.com' => 'QuestFinder',
				'^QweeryBot[ /]([0-9.]{1,10})' => 'Qweery',
				'www\.radian6\.com' => 'Radian6',
				'StackRambler[ /]([0-9.]{1,10})' => 'Rambler',
				'^ramiba(-bot)?' => 'ramiba',
				'^RedBot/redbot[ /\-]([0-9.]{1,10})' => 'rediff',
				'webmaster@repia\.com' => 'Repia',
				'Robozilla' => 'Robozilla',
				'Rojo[ /]([0-9.]{1,10})' => 'Rojo',
				'rss-bot[ /]([0-9.]{1,10})' => 'rss-bot',
				'RssBandit[ /]([0-9.]{1,10})' => 'RssBandit',
				'rssImagesBot[ /]([0-9.]{1,10})' => 'rssImages',
				'RSSMicro\.com' => 'RSSMicro',
				'RSSOwl[ /]([0-9a-z.]{1,10})' => 'RSSOwl',
				'RssReader[ /]([0-9.]{1,10})' => 'RssReader',
				'RufusBot' => 'RufusBot',
				'Runnk RSS finder' => 'Runnk',
				'MaSagool' => 'Sagool',
				'SanszBot' => 'Sansz',
				'Sauce[ ]?Reader[ /]([0-9.]{1,10})' => 'Sauce Reader',
				'SBIder[/ ]([0-9.]{1,10})' => 'SBIder',
				'SBIder[/ ]SBIder.([0-9.]{1,10})' => 'SBIder',
				'FAST-WebCrawler/[0-9a-z.]{1,10}/Scirus' => 'Scirus',
				'Scrubby[ /]([0-9.]{1,10})' => 'Scrubby',
				'Sun Download Manager[/ ]([0-9.]{1,10})' => 'SUN Download Manager',
				'SEA-Links( HTML-Scanner Pingoo\!)?[ /]([0-9.]{1,10})' => 'Sea Links',
				'search\.ch[ /]?V?([0-9.]{1,10})' => 'Search.ch',
				'searchengineworld' => 'SearchEngineWorld',
				'searchhippo' => 'Searchhippo',
				'www\.unitek-systems\.co\.uk[ /]([0-9.]{1,10})' => 'SearchThruUs',
				'securecomputing' => 'Secure Computing',
				'Seekbot[ /]([0-9.]{1,10})' => 'Seekport',
				'semanticdiscovery[ /]([0-9.]{1,10})' => 'Semantic Discovery',
				'^Sensis(.com.au)? Web Crawler' => 'Sensis',
				'SeznamBot[ /]([0-9.]{1,10})' => 'Seznam',
				'SharpReader[ /]([0-9.]{1,10})' => 'SharpReader',
				'sherlock_spider' => 'Sherlock Spider',
				'shim[ \-]crawler' => 'Shim Crawler',
				'^ShopWiki[ /]([0-9.]{1,10})' => 'ShopWiki',
				'^Shoula.com Crawler ([0-9.]{1,10})' => 'Shoula',
				'Siege[ /]([0-9.]{1,10})' => 'Siege',
				'SietsCrawler[ /]([0-9.]{1,10})' => 'Siets',
				'^(argus|simpy)[ /]([0-9.]{1,10})' => 'Simpy',
				'asterias[ /]([0-9.]{1,10})' => 'SingingFish',
				'Asterias Crawler v([0-9.]{1,10})' => 'SingingFish',
				'asterias' => 'SingingFish',
				'Sirketcebot[ /v]+([0-9.]{1,10})' => 'Sirketce',
				'sirobot' => 'SiroBot',
				'SiteBar[ /]([0-9.]{1,10})' => 'SiteBar',
				'SBIder[/ ]([0-9a-z.\-]{1,10})' => 'SiteSell',
				'^SiteSpider' => 'SiteSpider',
				'SitiDiBot[ /]([0-9.]{1,10})' => 'SitiDi',
				'Skampy[ /]([0-9.\-]{1,10})' => 'Skaffe',
				'SKIZZLE! Distributed Internet Spider[ /v]+([0-9a-z.\-]{1,10})' => 'Skizzle',
				'^slug\.ch crawl ([0-9a-z.\-]{1,10})' => 'slugch',
				'^Snoopy.+([0-9.]{1,10})' => 'Snoopy',
				'sna-([0-9.]{1,10})' => 'Snoopy',
				'^SnykeBot[ /]([0-9.]{1,10})' => 'Snyke',
				'^Slider[ /]([0-9.]{1,10})' => 'Slider',
				'soegning\.dk[/ ]spider[ /]([0-9.]{1,10})' => 'S?gning',
				'Mozilla\@somewhere\.com' => 'somewhere.com',
				'^SWSBot-Images[ /]([0-9.]{1,10})' => 'SmartWareSoft',
				'SOFT411 Directory' => 'Soft411',
				'Sogou web spider[ /]([0-9.]{1,10})' => 'Sogou',
				'sohu[ \-](agent|search)' => 'Sohu',
				'Sopheus Project[ /]([0-9.]{1,10})' => 'Sopheus',
				'SoupPotBot' => 'SoupPot',
				'^SMBot[ /]([0-9.]{1,10})' => 'Specific Media',
				'^Sphere Scout.+([0-9.]{1,10})' => 'Sphere Scout',
				'^sproose[ /]([0-9a-z.]{1,10})' => 'sproose',
				'SpurlBot[/ ]([0-9.]{1,10})' => 'SpurlBot',
				'^Star Downloader( Pro)?' => 'Star Downloader',
				'Steeler[ /]([0-9.]{1,10})' => 'Steeler',
				'Strategic Board Bot' => 'Strategic Board',
				'^suchbaer\.de' => 'suchbaer.de',
				'^suchbot' => 'suchbot',
				'^gonzo([0-9]{1,2}).*www.suchen.de' => 'suchen.de',
				'^Suchknecht.at-Robot' => 'Suchknecht',
				'^suchpadbot[ /]([0-9.]{1,10})' => 'suchpad',
				'^Sunrise[ /]([0-9a-z.]{1,10})' => 'Sunrise',
				'SuperBot[ /]([0-9.]{1,10})' => 'SuperBot',
				'SurfControl' => 'SurfControl',
				'ScSpider[ /]([0-9.]{1,10})' => 'SurfControl',
				'AVSearch[ \-]([0-9.]{1,10})' => 'SURFnet',
				'Submission Spider at surfsafely.com' => 'Surfsafely',
				'SurveyBot[ /]([0-9.]{1,10})' => 'Whois Survey',
				'^Swooglebot[ /]([0-9.]{1,10})' => 'Swoogle',
				'sw\.deri\.org' => 'SWSE',
				'www.sygol.(com|net)' => 'Sygol',
				' Synapse\)' => 'Synapse',
				'^\!Susie' => 'sync2it',
				'^SyncIT[ /]([0-9.]{1,10})' => 'syncit',
				'Syndic8[ /]([0-9.]{1,10})' => 'Syndic8',
				'Syndicatie\.nl robot v ([0-9.]{1,10})' => 'Syndicatie.nl',
				'Syndicatie\.nl robot;' => 'Syndicatie.nl',
				'^SynoBot' => 'Synomia',
				'SynooBot[ /]([0-9.]{1,10})' => 'SynooBot',
				'Szukacz[ /]([0-9.]{1,10})' => 'Szukacz',
				'^Tagword' => 'Tagword',
				'^Trailfire-bot[ /]([0-9.]{1,10})' => 'Trailfire',
				'IRLbot[ /]([0-9.]{1,10})' => 'Tamu Crawler',
				'TAMU_CS_IRL_CRAWLER[ /]([0-9.]{1,10})' => 'Tamu Crawler',
				'TargetSeek[ /]([0-9.]{1,10})' => 'TargetSeek',
				'^TCDBOT/Nutch-([0-9.]{1,10})' => 'Trinity College Dublin',
				'Technoratibot[ /]([0-9.]{1,10})' => 'Technorati',
				'Teleport[ \-]?Pro' => 'Teleport',
				'^Fresh Search :: Terrar' => 'Terrar',
				'Theophrastus[ /]([0-9.]{1,10})' => 'Theophrastus',
				'^thumbnail\.cz robot[ /]([0-9.]{1,10})' => 'thumbnails.cz',
				'^thumbshots.*(Version: |v)([0-9.]{2,10})e' => 'thumbshots',
				'^thumbshots-de' => 'thumbshots',
				'Thunderbird[ /]([0-9a-z.]{1,10})' => 'Thunderbird',
				'T-H-U-N-D-E-R-S-T-O-N-E' => 'Thunderstone',
				'timboBot' => 'timboBot',
				'traycebot[ /]([0-9a-z.\-]{1,10})' => 'trayce',
				'B_l_i_t_z_B_O_T_@_t_r_i_c_u_s_\._c_o_m' => 'Tricus',
				'topicblogs[ /]([0-9.]{1,10})' => 'Topicblogs',
				'tuezilla.de' => 'T?zilla',
				'TurnitinBot[ /]([0-9.]{1,10})' => 'Turnitin',
				'TutorGig(Bot)?[ /]([0-9.]{1,10})' => 'TutorGig',
				'Twiceler[ /-]([0-9.]{1,10})' => 'cuill',
				'Twiceler' => 'cuill',
				'TypePad/([0-9a-z.]{1,10})' => 'TypePad',
				'UdmSearch[/ ]([0-9.]{1,10})' => 'UdmSearch',
				'^Mackster.*ukwizz' => 'UKWizz',
				'Ultraseek' => 'Ultraseek',
				'UltraSpider3000[/ ]([0-9.]{1,10})' => 'UltraSpider',
				'umai[/ ]([0-9.]{1,10})' => 'umai',
				'unchaos_crawler[_ /]([0-9.]{1,10})' => 'Unchaos',
				'unchaos' => 'Unchaos',
				'^unido-bot' => 'unido',
				'updated[ /]([0-9a-z.]{1,10})' => 'Updated',
				'^UptimeBot' => 'UptimeBot',
				'^URI::Fetch[ /]([0-9.]{1,10})' => 'URI::Fetch',
				'URLBase[ /]([0-9.]{1,10})' => 'URLBase',
				'^URLBlaze' => 'URLBlaze',
				'Microsoft URL[ \-]?Control' => 'MS URL Control',
				'^URLGetFile' => 'URLGetFile',
				'UrlScope' => 'UrlScope',
				'Snappy/([0-9.]{1,10})' => 'urltrends',
				'usww\.com' => 'usww',
				'Mozilla/5\.0 URL-Spider' => 'usww',
				'^USyd-NLP-Spider' => 'USyd-NLP-Spider',
				'Vagabondo[ /]([0-9.]{1,10})' => 'WiseGuys',
				'Vagabondo-WAP[ /]([0-9.]{1,10})' => 'WiseGuys',
				'W3C_Validator[ /]([0-9.]{1,10})' => 'W3C Validator',
				'^vspider[ /]([0-9.]{1,10})' => 'Verity',
				'^vspider' => 'Verity',
				'InfoFly[ /]([0-9.]{1,10})' => 'Versions-project',
				'^VMBot[ /]([0-9.]{1,10})' => 'VerticalMatch',
				'Verzamelgids[ /]([0-9.]{1,10})' => 'Verzamelgids',
				'AlkalineBOT[ /]([0-9.]{1,10})' => 'Vestris',
				'Vindex[ /]([0-9.]{1,10})' => 'Vindex',
				'VisBot[ /]([0-9.]{1,10})' => 'Visvo',
				'VoilaBot[ /]?[a-z ]*([0-9.]{1,10})' => 'Voila',
				'VoilaBot;[ /]([0-9.]{1,10})' => 'Voila',
				'Vonna.com b o t' => 'Vonna',
				'Vortex[ /]([0-9.]{1,10})' => 'Vortex',
				'^W3SiteSearch Crawler[\_v]*([0-9.]{1,10})' => 'W3SiteSearch',
				'^Waggr' => 'Wagger',
				'^SurferF3[ /]([0-9./]{1,10})' => 'Wanadoo',
				'wapalizer[ /]([0-9.]{1,10})' => 'Wapalizer',
				'Watson[ /]([0-9.]{1,10})' => 'Dr.Watson',
				'watson\.addy\.com' => 'Dr.Watson',
				'^Wavefire[ /]([0-9.]{1,10})' => 'Wavefire',
				'Waypath[ \-]?Scout' => 'Waypath',
				'Waypath (development )?crawler' => 'Waypath',
				'^WDG_(Site)?Validator[/ ]([0-9.]{1,10})' => 'WDG Validator',
				'^Webagogo' => 'Webagogo',
				'^WebAlta( Crawler)?[/ ]([0-9.]{1,10})' => 'WebAlta',
				' Webbot[/ ]([0-9.]{1,10})' => 'Webbot.ru',
				'WebCapture[/ ]([0-9.]{1,10})' => 'WebCapture',
				'webcollage' => 'Webcollage',
				'WebCopier[/ ]v?([0-9.]{1,10})' => 'WebCopier',
				'webcrawl\.net' => 'WebCrawl',
				'Web Downloader[/ ]([0-9.]{1,10})' => 'Web Downloader',
				'^webfetch[/ ]([0-9.]{1,10})' => 'webfetch',
				'^WebFindBot' => 'Webfind',
				'^Webglimpse[/ ]([0-9.]{1,10})' => 'Webglimpse',
				'^webGobbler[/ ]([0-9.]{1,10})' => 'webGobbler',
				'^WebImages[/ ]([0-9.]{1,10})' => 'WebImages',
				'^WebLight[/ ]([0-9.]{1,10})' => 'WebLight',
				'^Weblink.s checker' => 'WebLink\'s',
				'^webmeasurement-bot' => 'Webmeasurement',
				'^WebMiner[/ ]([0-9.]{1,10})' => 'WebMiner',
				'^webmin' => 'Webmin',
				'WebMon[ /]([0-9.]{1,10})' => 'Webmon',
				'^WebPatrol[ /]([0-9.]{1,10})' => 'WebPatrol',
				'WebPix[/ ]([0-9.]{1,10})' => 'WebPix',
				'^WebRACE[/ ]([0-9.]{1,10})' => 'WebRACE',
				'^WebReaper ' => 'WebReaper',
				'Der webresult\.de Robot' => 'Webresult',
				'WebRingChecker[/ ]([0-9.]{1,10})' => 'Webring Checker',
				'WeBoX[/ ]([0-9.]{1,10})' => ' WeBoX',
				'WebSearch.COM.AU[/ ]+([0-9.]{1,10})' => 'WebSearch.COM.AU',
				'WebSearchBench WebCrawler[v/ ]+([0-9.]{1,10})' => 'WebSearchBench',
				'(Sqworm|websense|Konqueror/3\.(0|1)(-rc[1-6])?; i686 Linux; 2002[0-9]{4})' => 'Websense',
				'WebsiteWorth[v/ ]+([0-9.]{1,10})' => 'WebsiteWorth',
				'webs(quash\.com|ite[ \-]?Monitor)' => 'Websquash',
				'WebStripper[ /]([0-9.]{1,10})' => 'WebStripper',
				'Web[ \-]?ZIP[ /]([0-9.]{1,10})' => 'WebZIP',
				'WEP Search[ /]([0-9.]{1,10})' => 'WEP Search',
				'^West Wind Internet Protocols[ /]([0-9.]{1,10})' => 'West Wind Internet Protocols',
				'Wget[ /]([0-9.]{1,10})' => 'Wget',
				'WhizBang' => 'WhizBang',
				'^WebFetch' => 'WingFlyer',
				'TeamSoft WinInet Component' => 'WinInet',
				'WinHttp\.WinHttpRequest\.([0-9.]{1,10})' => 'WinHTTP',
				'^WIRE[ /]([0-9.]{1,10})' => 'WIRE',
				'^WMP' => 'WMP',
				'^WordChampBot' => 'WordChamp',
				'WordPress[ /]([0-9.]{1,10})' => 'WordPress',
				'^WorldLight' => 'WorldLight',
				'WorQmada[ /]([0-9.]{1,10})' => 'WorQmada',
				'Wotbox[ /]?[a-z]*([0-9.]{1,10})' => 'Wotbox',
				'NetSprint[ /\-]{1,4}([0-9.]{1,10})' => 'Wirtualna Polska',
				'WSB WebCrawler V([0-9.]{1,10})' => 'WebSearchBench',
				'WSB ' => 'WebSearchBench',
				'^wume_crawler[ /]([0-9.]{1,10})' => 'WUME Lab\'s',
				'Wusage[ /]([0-9.]{1,10})' => 'Wusage',
				'wwgrapevine[ /]([0-9.]{1,10})' => 'WWgrapevine',
				'WWSBOT[ /]([0-9.]{1,10})' => 'WWSBOT',
				'^www4mail[ /]([0-9.]{1,10})' => 'www4mail',
				'^WWWC[ /]([0-9.]{1,10})' => 'WWWC',
				'^WWWD[ /]([0-9.]{1,10})' => 'WWWD',
				'WWWeasel( Robot)?[/ ]v?([0-9.]{1,10})' => 'WWWeasel',
				'www\.fi crawler' => 'www.fi',
				'^WWW-Mechanize[/ ]([0-9.]{1,10})' => 'WWW-Mechanize',
				'^wwwoffle[/ ]([0-9.]{1,10})' => 'WWWoffle',
				'^wwwster[/ ]([0-9.]{1,10})' => 'WWWster',
				'Wysigot[/ ]([0-9.]{1,10})' => 'Wysigot',
				'Xaldon WebSpider' => 'Xaldon',
				'Xenu(\'s)? Link Sleuth[/ ]([0-9a-z.]{1,10})' => 'Xenu Link Sleuth',
				'Xenu_Link_Sleuth_([0-9a-z.]{1,10})' => 'Xenu Link Sleuth',
				'^Xerka WebBot v([0-9a-z.]{1,10})' => 'Xerka',
				'^xirq[ /]([0-9a-z.]{1,10})' => 'XIRQ',
				'^XMLSlurp[ /]([0-9a-z.]{1,10})' => 'XMLSlurp',
				'XMLRPC' => 'Trackback',
				'yacy\.net' => 'Yacy',
				'Yahoo(! ([a-z]{1,3} )?Slurp|-)' => 'Yahoo',
				'Yahoo-MMCrawler[/ ]([0-9a-z.]{1,10})' => 'Yahoo',
				'Yahoo-VerticalCrawler-FormerWebCrawler[/ ]([0-9a-z.]{1,10})' => 'Yahoo',
				'^AnzwersCrawl[/ ]([0-9a-z.]{1,10})' => 'Yahoo',
				'Y!J(-BSC|-SRD)*[/ ]([0-9a-z.]{1,10})' => 'Yahoo',
				'Y!OASIS/TEST' => 'Yahoo',
				'Harvest-NG[/ ]([0-9a-z.]{1,10})' => 'Yahoo',
				'Y!J; for robot study' => 'Yahoo',
				'Yahoo Japan; for robot study' => 'Yahoo',
				'^YahooFeedSeeker[/ ]([0-9a-z.]{1,10})' => 'Yahoo Feedseeker',
				'Yandex[/ ]([0-9.]{1,10})' => 'Yandex',
				'^yarienavoir.net[/ ]([0-9.]{1,10})' => 'Yarienavoir',
				'YellCrawl[ /]V?([0-9.]{1,10})' => 'Yell',
				'Yellbot[ /]Nutch-([0-9.]{1,10})' => 'Yell',
				'YodaoBot(-Image|)?[ /]([0-9.]{1,10})' => 'Yodao',
				'yoogliFetchAgent[ /]([0-9.]{1,10})' => 'Yoogli',
				'Yotta(Shopping|Cars)_Bot[ /]([0-9.]{1,10})' => 'Yotta',
				'OmniExplorer_Bot[ /]([0-9.]{1,10})' => 'Yotta',
				'Yoono' => 'Yoono',
				'Gulper Web Bot[ /]([0-9.]{1,10})' => 'yuntis',
				'Zao[ /]([0-9.]{1,10})' => 'Zao',
				'Zao-crawler' => 'Zao',
				'Zealbot[ /]([0-9.]{1,10})' => 'ZealBot',
				'Zearchit' => 'Zearchit',
				'^ZeBot_(lseek\.net|www\.ze\.bz)' => 'ze.bz',
				'zedzo.digest[ /]([0-9.]{1,10})' => 'Zedzo',
				'^zerxbot[ /](Version|v)*[ /]*([0-9.]{1,10})' => 'Zerx',
				'Zeus' => 'Zeus',
				'ZipppBot[ /]([0-9.]{1,10})' => 'Zippp',
				'^Zippy[ v/]*([0-9.]{1,10})' => 'Zippy',
				'Zoekybot[ /]([0-9.]{1,10})' => 'Zoeky',
				'(WISE|Zy)bo(rg|t)[ /]([0-9.]{1,10})' => 'WiseNutBot',
				'^ZoomSpider' => 'zspider',
				'zspider[ /]([0-9.a-z]{1,10})' => 'zspider',
				'Blog[ \-]?Bot' => 'BlogBot',
				'holmes[/ ]([0-9.]{1,10})' => 'Centrum',
				'^Centrum-checker' => 'Centrum',
				'HTTP[ \-]?Client[ /]([0-9.]{1,10})' => 'HTTPClient',
				'HTTP[ \-]?Client' => 'HTTPClient',
				'^IncyWincy[ /]([0-9.]{1,10})' => 'IncyWincy',
				'^IncyWincy' => 'IncyWincy',
				'^java[ /]*([0-9.a-z]{1,10})' => 'Java',
				'^(fetch )?libfetch[ /]([0-9.]{1,10})' => 'Libfetch',
				'^libww(w|w-perl|w-FM)[ /]([0-9.]{1,10})' => 'libWWW',
				'^libww(w|w-perl|w-FM)' => 'libWWW',
				'MyApp.*libww(w|w-perl|w-FM)' => 'libWWW',
				'LiteFinder[ /]([0-9.]{1,10})' => 'LiteFinder',
				'Nutc(hOrg|hCVS|h)?[ /]([0-9.]{1,10})' => 'Nutch',
				'Nutch' => 'Nutch',
				'Python[ \-]?urllib' => 'Python-url',
				'NASA Search[/ ]([0-9.]{1,10})' => 'SPAM',
				'^PHOTO CHECK' => 'SPAM',
				'^FOTOCHECKER' => 'SPAM',
				'^IPTC CHECK' => 'SPAM',
				'^DataCha0s' => 'SPAM',
				'^Mac Finder' => 'SPAM',
				'^Missigua Locator[ /]([0-9.]{1,10})' => 'SPAM',
				'^Missouri College Browse' => 'SPAM',
				'Email[ \-]?Siphon' => 'SPAM',
				'atSpider' => 'SPAM',
				'autoemailspider' => 'SPAM',
				'^Demo Bot' => 'SPAM',
				'^Program Shareware' => 'SPAM',
				'^Snapbot' => 'SPAM',
				'^snap.com' => 'SPAM',
				'^Guestbook Auto Submitter' => 'SPAM',
				'panscient.com' => 'SPAM',
				'(robot|spider|harvest|bot|(?<!msie)crawler)' => 'Unknown Robot'
				);

$os = array (	'wi(n|ndows)?' => 'windows',
				'linux[ /\-]([a-z0-9._]{1,10})' => 'linux',
				'linux' => 'linux',
				'Mac[ _]?OS[ _]?X[ /]([0-9.]{1,10})' => 'macosx',
				'Mac[ _]?OS[ _]?X' => 'macosx',
				'Mac 10.([0-9.]{1,10})' => 'macosx',
				'Mac(_Power|intosh.+P)PC' => 'macppc',
				'beos[ a-z]*([0-9.]{1,10})' => 'beos',
				'beos' => 'beos',
				'fedora' => 'fedora',
				'free[ \-]?bsd[ /]([a-z0-9._]{1,10})' => 'freebsd',
				'free[ \-]?bsd' => 'freebsd',
				'open[ \-]?bsd[ /]([a-z0-9._]{1,10})' => 'openbsd',
				'open[ \-]?bsd' => 'openbsd',
				'PCLinuxOS[ /]?([0-9.]{1,10})' => 'pclinux',
				'ubuntu' => 'ubuntu'
				 );

$web_property = get_option('ua_tracking_code');
$cookie = get_option('utma_cookie');
				 
InsertBots ( strtolower($_SERVER['SERVER_NAME']) , $web_property , $cookie , $bots , $os  );
}
function InsertBots ( $domain , $gacode , $utma , $bots , $os ){
	#If a REFERER exists, we leave the function, since bots don't have referer. 
	if( !empty( $_SERVER['HTTP_REFERER'] ) )
		return;

	#If the visitor returns a known OS that is not a robot we leave the function.
	foreach( $os as $pattern => $o )
	{
		if ( preg_match( '#'.$pattern.'#msi' , $_SERVER['HTTP_USER_AGENT'] ) == 1 )
			return;
	}

	#We check what bot this is, then the insert in GA.
	foreach( $bots as $pattern => $bot )
	{
		if ( preg_match( '#'.$pattern.'#i' , $_SERVER['HTTP_USER_AGENT'] ) == 1 )
		{
			$botname = preg_replace ( '/\\s{1,}/i' , '-' , $bot );		//Bot Name
			$uri = $_SERVER['REQUEST_URI'];								//Requested URI by Crawler
			
			
			$var_utmn = rand( 1000000000,9999999999 );							//random request number
			$var_utmdt = '';//urlencode( wp_title() );							//Visited page name
			$var_server = gethostbyaddr( $_SERVER['REMOTE_ADDR'] ); 			//server url
			$var_utmp = $uri;													//Page views per visitor
			$var_random = rand( 1000000000,2000000000 ); 						//number under 2147483647
			$var_now = time(); 													//today
			
			$urchinUrl .= 'http://www.google-analytics.com/__utm.gif?';
			$urchinUrl .= 'utmwv=1';
			$urchinUrl .= '&utmn='.$var_utmn;				//Random Number
			$urchinUrl .= '&utmsr=-';						//Screem Resolution
			$urchinUrl .= '&utmsc=-';						//Screen quality
			$urchinUrl .= '&utmul=-';						//Visitor language
			$urchinUrl .= '&utmje=0';						//Java enabled
			$urchinUrl .= '&utmfl=-';						//Flash version
			$urchinUrl .= '&utmdt='.$var_utmdt;				//Visited page name
			$urchinUrl .= '&utmhn='.$domain;				//Website name
			$urchinUrl .= '&utmr=-';						//not referer
			$urchinUrl .= '&utmp='.$var_utmp;				//Page views per visitor
			//$urchinUrl .= '&utme=-';						//Name???(Objet*Action*Label) => 5(Robots*Bot Name*Pathname)
			$urchinUrl .= '&utmac='.$gacode;				//Analytics account
			$urchinUrl .= '&utmcc=__utma%3D'.$utma.'.'.$var_random.'.'.$var_now.'.'.$var_now.'.'.$var_now.'.1%3B%2B__utmb%3D'.$utma.'%3B%2B__utmc%3D'.$utma.'%3B%2B__utmz%3D'.$utma.'.'.$var_now.'.1.1.utmccn%3D(organic)%7Cutmcsr%3D'.$botname.'%7Cutmctr%3D'.$uri.'%7Cutmcmd%3Dorganic%3B%2B__utmv%3D'.$utma.'.Robot%20hostname%3A%20'.$var_server.'%3B';										

			
			#Injection of the page in Google Analytics
			$cu = curl_init();
			curl_setopt($cu, CURLOPT_HEADER, 1);
			curl_setopt($cu, CURLOPT_RETURNTRANSFER, 1);			
			curl_setopt($cu, CURLOPT_URL, $urchinUrl);
			$code = curl_exec($cu);			
			curl_close($cu);
			
			return;
		}
	}
}
?>